package fos

import Term._

/** This object is meant to implement an evaluator for the NB language of booleans and numbers
 *  found in Chapter 3 of the TAPL book.
 *  Your job is to replace the missing parts (indicated by `???`) with valid implementartions.
 *  Note that `???` is a valid Scala expression, and can be used in place of an implementation
 *  while you are still working on other parts of the code.
 */
object Arithmetic {

  case class NoReductionPossible(t: Term) extends Exception(t.toString)

  /** Return a list of at most n terms, each being one step of reduction. */
  def path(t: Term, n: Int = 64): List[Term] =
    if n <= 0 then Nil
    else t :: {
        try path(reduce(t), n - 1) catch
          case NoReductionPossible(t1) =>
            Nil
      }

  /** Perform one step of reduction, when possible.
   *  If reduction is not possible NoReductionPossible exception
   *  with corresponding irreducible term should be thrown.
   */
  def reduce(t: Term): Term =
    ???

  case class TermIsStuck(t: Term) extends Exception(t.toString)

  /** Perform big step evaluation (result is always a value.)
   *  If evaluation is not possible TermIsStuck exception with
   *  corresponding inner irreducible term should be thrown.
   */
  def eval(t: Term): Term =
    ???

}
